<?php

/* ----------------------
		SLAVE SYNC
   ----------------------  */
if (array_key_exists('debug', $_GET)) {
	setcookie('debug',$_GET['debug'],0,'/');
	$_COOKIE['debug'] = $_GET['debug'];
}

// Defines functions for the slave websites to sync with the master website via the theme api

// Add buttons to dashboard
add_action('wp_dashboard_setup', 'add_gulf_dashboard_widgets' );
function add_gulf_dashboard_widgets() {
//	wp_add_dashboard_widget('sync', 'Gulf Oil', 'gulf_dashboard_sync');
	add_meta_box('sync', 'Gulf Oil', 'gulf_dashboard_sync', 'dashboard', 'side', 'high');
}
function gulf_dashboard_sync() {
	?>
	<p>Clicking the button below will load the latest content from Gulf Oil International site.</p>
	<input type="submit" value="Load Shared Content" class="button button-primary" id="SyncButton"/>
	<p id="SyncOutput" style="display:none;"></p>
	<hr/>
	<p>Clicking the button below will back-up your database.</p>
	<input type="submit" value="Backup Database" class="button button-primary" id="BackupButton"/>
	<p id="BackupOutput" style="display:none;"></p>
	<hr/>
	<p>Clicking the button below will unlock the shared pages. Once unlocked, you can take ownership or a page and edit or delete it.</p>
	<input type="submit" value="Unlock Content" class="button button-primary" id="UnlockButton"/>
	<p id="UnlockOutput" style="display:none;"></p>
	<?php
}


// Check for content
add_action('wp_ajax_gulf_backup_database','gulf_backup_database_button',11);
function gulf_backup_database_button() {
	gulf_backup_database_before_install();
	?>Database has been backed-up.<?php
	die();
}


// Check for content
add_action('wp_ajax_check_for_new_items','gulf_sharing_force_check_for_new_items',11);
function gulf_sharing_force_check_for_new_items() {
	gulf_sharing_check_for_new_items(true);
}


//add_action('admin_init','gulf_sharing_check_for_new_items',11);
function gulf_sharing_check_for_new_items($force=false) {
	global $wpdb,$missinguuids;
	
	error_reporting(E_ALL);
	ini_set('display_errors', 1);
	
	set_time_limit(300);
	
	$debug = getCookie('debug');
	
	$lastcheck = get_transient('gulf_sharing_last_check');

	if ($force || $lastcheck < time()-SHARING_INTERVAL) {
		$url = trailingslashit(THEME_URL).'api/?caller='.home_url().'&compress=0';
		if (SHARING_INTERVAL == 0) {
			//$url .= '&force=1';
		}

		$json = gulf_curl($url);
		$items = json_decode($json);
		
		// POSTS
		foreach ($items->posts as $j => $item) {
			$p = $wpdb->get_row( $wpdb->prepare("SELECT * FROM $wpdb->posts WHERE guid=%s",$item->details->guid) );
			
			if (empty($p)) {
				$ID = wp_insert_post(array(
					'post_type' => $item->details->post_type,
					'post_date' => $item->details->post_date,
					'post_date_gmt' => $item->details->post_date_gmt,
					'guid' => $item->details->guid,
					'post_title' => $item->details->post_title,
					'post_name' => $item->details->post_name,
					'post_content' => $item->details->post_content,
					'post_excerpt' => $item->details->post_excerpt,
					'menu_order' => $item->details->menu_order,
					'author' => -1,
					'post_status' => 'publish',
				));
			} else {
				$p->post_date = $item->details->post_date;
				$p->post_date_gmt = $item->details->post_date_gmt;
				$p->post_title = $item->details->post_title;
				$p->post_name = $item->details->post_name;
				$p->menu_order = $item->details->menu_order;
				$p->post_content = $item->details->post_content;
				$p->post_excerpt = $item->details->post_excerpt;
				wp_update_post($p);
				$ID = $p->ID;
			}

			// Loop meta
			foreach ($item->meta as $field => $value) {
				update_post_meta($ID,$field,$value);
			}
			
			// Do custom fields
			if (!empty($item->fields)) {
				$post = new PostType($ID);
				$post->processFields($item->fields);
			}
			
			// Add attachments
			if (!empty($item->attachments)) {
				foreach ($item->attachments as $attachment) {
					$mime = explode('/',$attachment->post_mime_type);
					if ($mime[0] == 'image') {
						$file = Image::getByUUID($attachment->uuid);
					} else {
						$file = Document::getByUUID($attachment->uuid);
					}
					if (empty($file)) {
						gulf_create_image_id($attachment->guid,$attachment->uuid,$ID);
					}
				}
			}
			
			if (!empty($item->featured)) {
				$file = Image::getByUUID($item->featured[1]);
				if (empty($file)) {
					$fileid = gulf_create_image_id($item->featured[0],$item->featured[1],$ID);
				} else {
					$fileid = $file->ID;
				}
				if ($fileid) {
					set_post_thumbnail($ID,$fileid);
				}
			}
			
		}
		
		// Set parents
		foreach ($items->posts as $j => $item) {
			if ($item->details->post_parent) {
				$parent = PostType::getByUUID($item->details->post_parent);
				$item = PostType::getByUUID($item->meta->uuid);
				if ($parent) {
					wp_update_post((object) array(
						'ID' => $item->ID,
						'post_parent' => $parent->ID,
					));
				}
			}
		}
		
		
		// Remove protection on any items not included
/*		foreach (PostType::allposttypes() as $posttype) {
			$postids = $wpdb->get_results('SELECT ID FROM wp_posts
				LEFT JOIN wp_postmeta ON wp_postmeta.post_id = ID
				WHERE post_type IN ("'.$posttype.'")
				AND meta_key = "uuid"
				AND meta_value NOT IN ("'.implode('","',array_keys($uuids)).'")');
			foreach ($postids as $postid) {
				delete_post_meta($postid->ID,'gulf_sharing_share');
			}
		}*/

		
		
		// TERMS
		foreach ($items->taxes as $item) {
			// Check if item exists
			$exists = $wpdb->get_row("SELECT * FROM $wpdb->termmeta WHERE meta_key='uuid' AND meta_value='".$item->meta->uuid."'");
			
			if (empty($exists)) {
				$term = wp_insert_term($item->details->name,$item->details->taxonomy,array(
					'description' => $item->details->description,
					'slug' => $item->details->slug,
				));
				if (is_array($term)) {
					update_term_meta($term['term_id'],'uuid',$item->meta->uuid);
					$termid = $term['term_id'];
				} else {
					// Possible exists
					$term = get_term_by('slug',$item->details->slug,$item->details->taxonomy);
					if ($term !== false) {
						$termid = $term->term_id;
					} else {
						$termid = false;
					}
				}
			} else {
				$termid = $exists->term_id;
			}

			if ($termid) {
				// Loop meta
				foreach ($item->meta as $field => $value) {
					update_term_meta($termid,$field,$value);
				}

				// Do custom fields
				if (!empty($item->fields)) {
					$term = new TermType($termid);
					$term->processFields($item->fields);
				}

				// Add children
				if ($item->children) {
					foreach ($item->children as $child) {
						$post = PostType::getByUUID($child);
						if ($post) {
							wp_set_object_terms($post->ID,$item->details->slug,$item->details->taxonomy,true);
						}
					}
				}
			}

		}
		
		
		
		// MENUS
		$menuids = array();
		foreach (get_terms( 'nav_menu', array( 'hide_empty' => false ) ) as $result) {
			$menuids[$result->slug] = $result->term_id;
		}
		if ($debug) print '<h3>Menus</h3>'.'<p>'.print_r($menuids,true).'</p>';
		foreach ($items->menus as $itemindex => $item) {
			if ($debug) print '<h4>Item '.$itemindex.' '.$item->menu.'</h4><p>'.print_r($item,true).'</p>';
			if (array_key_exists($item->menu,$menuids)) {
				if ($debug) print 'Type: '.$item->type.'<br/>';
				if ($item->type == 'post_type') {
					if ($debug) print 'UUID: '.$item->object_id.'<br/>';
					$post = PostType::getByUUID($item->object_id);
					if ($debug) print 'Post: '.print_r($post,true).'<br/>';
					if ($post) {
						// Check if item exists
						$exists = $wpdb->get_row("SELECT * FROM $wpdb->postmeta pm JOIN $wpdb->term_relationships tr ON tr.object_id = pm.post_id
							WHERE meta_key = '_menu_item_object_id' AND meta_value = $post->ID
							AND tr.term_taxonomy_id = ".$menuids[$item->menu]);
						if (empty($exists)) {
							$menuitemid = 0;
						} else {
							$menuitemid = $exists->post_id;
						}
						if ($debug) print 'Menu item id: '.$menuitemid.'<br/>';
						$parent = 0;
						if ($debug) print 'Menu_item_parent: '.$item->menu_item_parent.'<br/>';
						if ($item->menu_item_parent) {
							$parent = $wpdb->get_row("SELECT * FROM $wpdb->postmeta WHERE meta_key='uuid' AND meta_value='".$item->menu_item_parent."'");
							if ($parent) {
								if ($debug) print 'Parent: '.print_r($parent,true).'<br/>';
								$parent = $parent->post_id;
							}
						}
						$menuitemid = wp_update_nav_menu_item($menuids[$item->menu],$menuitemid,array(
							'menu-item-object' => $post->post_type,
							'menu-item-object-id' => $post->ID,
							'menu-item-parent-id' => $parent,
							'menu-item-title' => $post->post_title,
							'menu-item-target' => $item->target,
							'menu-item-position' => $item->menu_order,
							'menu-item-status' => 'publish',
							'menu-item-type' => $item->type,
						));
						update_post_meta($menuitemid,'uuid',$item->uuid);
					}
				}
			}
		}
		
		
		set_transient('gulf_sharing_last_check',time());
	}
	
	die();
}

function gulf_add_field($ID,$field) {
	
}

function gulf_create_image_id( $image_url, $uuid, $parent_post_id = null ) {
	if (empty($image_url)) {
		return;
	}
	
	$image_name       = basename($image_url);
	$upload_dir       = wp_upload_dir(); // Set upload folder
	$image_data       = gulf_curl($image_url); // Get image data
	if (empty($image_data)) {
		return false;
	}
	
	$unique_file_name = wp_unique_filename( $upload_dir['path'], $image_name ); // Generate unique name
	$filename         = basename( $unique_file_name ); // Create image file name

	// Check folder permission and define file location
	if( wp_mkdir_p( $upload_dir['path'] ) ) {
		$file = $upload_dir['path'] . '/' . $filename;
	} else {
		$file = $upload_dir['basedir'] . '/' . $filename;
	}

	// Create the image  file on the server
	file_put_contents( $file, $image_data );

	// Check image file type
	$wp_filetype = wp_check_filetype( $filename, null );

	// Set attachment data
	$attachment = array(
		'post_mime_type' => $wp_filetype['type'],
		'post_title'     => sanitize_file_name( $filename ),
		'post_content'   => '',
		'post_status'    => 'inherit'
	);

	// Create the attachment
	$attach_id = wp_insert_attachment( $attachment, $file, $parent_post_id );

	// Include image.php
	require_once(ABSPATH . 'wp-admin/includes/image.php');

	// Define attachment metadata
	$attach_data = wp_generate_attachment_metadata( $attach_id, $file );

	// Assign metadata to attachment
	wp_update_attachment_metadata( $attach_id, $attach_data );
	
	update_post_meta($attach_id,'uuid',$uuid);
	
	return $attach_id;
}





add_action('admin_init','gulf_sharing_sync_fields',10);
function gulf_sharing_sync_fields() {
	// vars
	if (!function_exists('acf_get_field_groups')) {
		return;
	}
	$groups = acf_get_field_groups();
	$sync 	= array();
	// bail early if no field groups
	if( empty( $groups ) )
		return;
	
	// find JSON field groups which have not yet been imported
	foreach( $groups as $group ) {
		
		// vars
		$local 		= acf_maybe_get( $group, 'local', false );
		$modified 	= acf_maybe_get( $group, 'modified', 0 );
		$private 	= acf_maybe_get( $group, 'private', false );
		// ignore DB / PHP / private field groups
		if( $local !== 'json' || $private ) {
			// do nothing
			
		} elseif( ! $group[ 'ID' ] ) {
			$sync[ $group[ 'key' ] ] = $group;
			
		} elseif( $modified && $modified > get_post_modified_time( 'U', true, $group[ 'ID' ], true ) ) {
			$sync[ $group[ 'key' ] ]  = $group;
		}
	}
	// bail if no sync needed
	if( empty( $sync ) )
		return;
	
	if( ! empty( $sync ) ) { //if( ! empty( $keys ) ) {
		$new_ids = array();
		foreach( $sync as $key => $v ) { //foreach( $keys as $key ) {
			// append fields
			if( acf_have_local_fields( $key ) ) {
				$sync[ $key ][ 'fields' ] = acf_get_local_fields( $key );
			}
			// import
			$field_group = acf_import_field_group( $sync[ $key ] );
		}
	}
}


// Usage - http://domain/wp-admin/admin-ajax.php?action=gulf_unlock
add_action('wp_ajax_gulf_unlock','gulf_unlock');
function gulf_unlock() {
	global $wpdb;
	$wpdb->update($wpdb->postmeta,array('meta_value'=>'ownable'),array('meta_key'=>'gulf_sharing_privileges','meta_value'=>'translatable'));
}