<?php
// SIDEBARS AND WIDGETIZED AREAS
function gulf_register_sidebars() {
	register_sidebar(array(
		'id' => 'sidebar1',
		'name' => __('Sidebar 1', 'gulfoil'),
		'description' => __('The first (primary) sidebar.', 'gulfoil'),
		'before_widget' => '<div id="%1$s" class="widget %2$s">',
		'after_widget' => '</div>',
		'before_title' => '<h4 class="widgettitle">',
		'after_title' => '</h4>',
	));
	
	register_sidebar(array(
		'id' => 'sidebar2',
		'name' => __('Sidebar 2', 'gulfoil'),
		'description' => __('The secondary sidebar.', 'gulfoil'),
		'before_widget' => '<div id="%1$s" class="widget %2$s">',
		'after_widget' => '</div>',
		'before_title' => '<h4 class="widgettitle">',
		'after_title' => '</h4>',
	));

	register_sidebar(array(
		'id' => 'footer',
		'name' => __('Footer', 'gulfoil'),
		'description' => __('The footer sidebar.', 'gulfoil'),
		'before_widget' => '<div id="%1$s" class="widget %2$s columns">',
		'after_widget' => '</div>',
		'before_title' => '<h4 class="widgettitle">',
		'after_title' => '</h4>',
	));


} 


add_action('in_widget_form','gulf_add_sidebar_column_selector',10,3);
function gulf_add_sidebar_column_selector($widget, $return, $instance) {
	$instance['gulf_widget_columns'] = isset( $instance['gulf_widget_columns'] ) ? $instance['gulf_widget_columns'] : 4;
	
	$sidebarid = gulf_get_sidebar_id_from_widget_id($widget->id);
	
	switch ($sidebarid) {
		case 'footer':
			?>
			<p>
				<label for="<?php echo esc_attr( $widget->get_field_id('gulf_widget_columns') ); ?>"><?php _e( 'Columns (12 per row)', 'gulfoil' ) ?></label>
				<select name="<?php echo esc_attr( $widget->get_field_name('gulf_widget_columns') ); ?>" id="<?php echo esc_attr( $widget->get_field_id('gulf_widget_columns') ); ?>" class="widefat">
					<?php
					for ($i=1; $i<=12; $i++) {
						?><option value="<?php print $i ?>" <?php echo selected( $instance['gulf_widget_columns'], $i ) ?>><?php print $i ?></option><?php
					}
					?>
				</select>
			</p>
			<?php
	}
}


function gulf_get_sidebar_id_from_widget_id( $widget_id ) {
    $sidebars = wp_get_sidebars_widgets();
    foreach( (array) $sidebars as $sidebar_id => $sidebar ) {
        if( in_array( $widget_id, (array) $sidebar, true ) ) {
            return $sidebar_id;
		}
    }
    return null; // not found case
}

function gulf_get_widget_by_id($id,$sidebar_id) {
	$sidebars_widgets = wp_get_sidebars_widgets();
	if (!array_key_exists($sidebar_id, $sidebars_widgets)) {
		return;
	}
	$widget_ids = $sidebars_widgets[$sidebar_id];
	foreach ($widget_ids as $widget_id) {
		if ($id == $widget_id) {
			$idvar = _get_widget_id_base( $id );
			$wdgtvar = 'widget_'.$idvar;
			$instance = get_option( $wdgtvar );
			$idbs = str_replace( $idvar.'-', '', $id );
			return $instance[$idbs];
		}
		
	}
}


add_filter( 'widget_update_callback', 'gulf_update_widget_options' , 10, 3 );
function gulf_update_widget_options($instance, $new_instance, $old_instance) {
	$instance['gulf_widget_columns'] = isset($new_instance['gulf_widget_columns']) ? $new_instance['gulf_widget_columns'] : 4;
	
	return $instance;
}

add_filter('dynamic_sidebar_params','gulf_dynamic_sidebar_params',10);
function gulf_dynamic_sidebar_params($params) {
	$sidebar_id = gulf_get_sidebar_id_from_widget_id($params[0]['widget_id']);
	switch ($sidebar_id) {
		case 'footer':
			$instance = gulf_get_widget_by_id($params[0]['widget_id'],$sidebar_id);
			$columns = isset($instance['gulf_widget_columns'])? $instance['gulf_widget_columns'] : 4;
			$params[0]['before_widget'] = str_replace('columns', 'columns medium-'.$columns, $params[0]['before_widget']);
			break;
	}
	return $params;
} 

