<?php
// Theme update checker
require 'theme-update-checker.php';
$theme_url = defined('THEME_URL')? THEME_URL : 'http://theme.gulfoilltd.com';
$example_update_checker = new ThemeUpdateChecker(
	'gulf-oil',
	$theme_url.'/gulf-oil-theme.json' 
);



	
// Modify theme after activation
add_action( 'after_setup_theme', 'gulf_theme_support' );
function gulf_theme_support() {

	// Add WP Thumbnail Support
	add_theme_support( 'post-thumbnails' );
	
	// Default thumbnail size
	set_post_thumbnail_size(125, 125, true);

	// Add RSS Support
	add_theme_support( 'automatic-feed-links' );
	
	// Add Support for WP Controlled Title Tag
	add_theme_support( 'title-tag' );
	
	// Add HTML5 Support
	add_theme_support( 'html5', 
	         array( 
	         	'comment-list', 
	         	'comment-form', 
	         	'search-form', 
	         ) 
	);
	
	// Adding post format support
	 add_theme_support( 'post-formats',
		array(
			'aside',             // title less blurb
			'gallery',           // gallery of images
			'link',              // quick link to other site
			'image',             // an image
			'quote',             // a quick quote
			'status',            // a Facebook like status update
			'video',             // video
			'audio',             // audio
			'chat'               // chat transcript
		)
	); 
	
	// Set the maximum allowed width for any content in the theme, like oEmbeds and images added to posts.
	$GLOBALS['content_width'] = apply_filters( 'gulf_theme_support', 1200 );		
	
} /* end theme support */





