<?php
add_action( 'widgets_init', create_function( '', 'register_widget( "ProductDetails_Widget" );' ) );

class ProductDetails_Widget extends WP_Widget {

	public function __construct() {
		$widget_ops = array( 'description' => __( "Shows product details","gulfoil") );
		parent::__construct( 'product_details', __('Product Details',"gulfoil"), $widget_ops );
	}

	public function widget($args, $instance) {
		global $post;
		
		if (!isset($post) || $post->post_type != 'gulfproduct') {
			return;
		}

		echo $args['before_widget'];

		$product = new Product($post);
		$featured = $product->featured;
		if ($featured) {
			print '<div class="imagery">'.$featured->src(240,240).'</div>';
		}

		$excerpt = apply_filters('the_excerpt',$product->post_excerpt);
		if ($excerpt) {
//			print '<div class="excerpt">'.$excerpt.'</div>';
		}
		
		$details = apply_filters('post_content',$product->getField('details'));
		if ($details) {
			print '<div class="details">'.$details.'</div>';
		}


		echo $args['after_widget'];
	}

	
	public function update( $new_instance, $old_instance ) {
		$instance = array();
		return $instance;
	}

	public function form( $instance ) {
		?>
<p>Will only show on product pages</p>
		<?php
	}
}
